3 # Fake Root Solaris/SVR4/SVR5 Build System - Prototype
5 # The following code has been provide under Public Domain License. I really
6 # don't care what you use it for. Just as long as you don't complain to me
7 # nor my employer if you break it. - Ben Lindstrom (mouring@eviladmin.org)
11 # Options for building the package
12 # You can create a openssh-config.local with your customized options
14 REMOVE_FAKE_ROOT_WHEN_DONE
=yes
16 # uncommenting TEST_DIR and using
17 # configure --prefix=/var/tmp --with-privsep-path=/var/tmp/empty
19 # PKGNAME=tOpenSSH should allow testing a package without interfering
20 # with a real OpenSSH package on a system. This is not needed on systems
21 # that support the -R option to pkgadd.
22 #TEST_DIR=/var/tmp # leave commented out for production build
24 # revisions within the same version (REV=a)
26 SYSVINIT_NAME
=opensshd
29 SSHDUID
=67 # Default privsep uid
30 SSHDGID
=67 # Default privsep gid
31 # uncomment these next three as needed
34 #USR_LOCAL_IS_SYMLINK=yes
35 # System V init run levels
38 # We will source these if they exist
39 POST_MAKE_INSTALL_FIXES
=.
/pkg-post-make-install-fixes.sh
40 POST_PROTOTYPE_EDITS
=.
/pkg-post-prototype-edit.sh
41 # We'll be one level deeper looking for these
42 PKG_PREINSTALL_LOCAL
=..
/pkg-preinstall.
local
43 PKG_POSTINSTALL_LOCAL
=..
/pkg-postinstall.
local
44 PKG_PREREMOVE_LOCAL
=..
/pkg-preremove.
local
45 PKG_POSTREMOVE_LOCAL
=..
/pkg-postremove.
local
46 PKG_REQUEST_LOCAL
=..
/pkg-request.
local
47 # end of sourced files
49 OPENSSHD
=opensshd.init
50 OPENSSH_MANIFEST
=openssh.xml
51 OPENSSH_FMRI
=svc
:/site
/${SYSVINIT_NAME}:default
53 PATH_GROUPADD_PROG
=@PATH_GROUPADD_PROG@
54 PATH_USERADD_PROG
=@PATH_USERADD_PROG@
55 PATH_PASSWD_PROG
=@PATH_PASSWD_PROG@
57 # list of system directories we do NOT want to change owner/group/perms
58 # when installing our package
69 /lib/svc/method/site \
94 /var/svc/manifest/site \
98 # We may need to build as root so we make sure PATH is set up
99 # only set the path if it's not set already
101 echo $PATH |
grep ":/opt/bin" > /dev
/null
2>&1
102 [ $?
-ne 0 ] && PATH
=$PATH:/opt
/bin
104 [ -d /usr
/local
/bin
] && {
105 echo $PATH |
grep ":/usr/local/bin" > /dev
/null
2>&1
106 [ $?
-ne 0 ] && PATH
=$PATH:/usr
/local
/bin
108 [ -d /usr
/ccs
/bin
] && {
109 echo $PATH |
grep ":/usr/ccs/bin" > /dev
/null
2>&1
110 [ $?
-ne 0 ] && PATH
=$PATH:/usr
/ccs
/bin
116 echo "Please run this script from your build directory"
120 # we will look for openssh-config.local to override the above options
121 [ -s .
/openssh-config.
local ] && . .
/openssh-config.
local
126 ## Fill in some details, like prefix and sysconfdir
127 for confvar
in prefix exec_prefix bindir sbindir libexecdir datadir mandir sysconfdir piddir srcdir
129 eval $confvar=`grep "^$confvar=" Makefile | cut -d = -f 2`
132 ## Are we using Solaris' SMF?
134 if egrep "^#define USE_SOLARIS_PROCESS_CONTRACTS" config.h
> /dev
/null
2>&1
139 ## Collect value of privsep user
140 for confvar
in SSH_PRIVSEP_USER
142 eval $confvar=`awk '/#define[ \t]'$confvar'/{print $3}' config.h`
145 ## Set privsep defaults if not defined
146 if [ -z "$SSH_PRIVSEP_USER" ]
148 SSH_PRIVSEP_USER
=sshd
151 ## Extract common info requires for the 'info' part of the package.
152 VERSION
=`./ssh -V 2>&1 | sed -e 's/,.*//'`
157 SCRIPT_SHELL
=/sbin
/sh
161 SunOS
) UNAME_S
=Solaris
165 DEF_MSG
="(default: n)"
167 SCO_SV
) case ${UNAME_R} in
168 3.2) UNAME_S
=OpenServer5
169 OS_VER
=`uname -X | grep Release | sed -e 's/^Rel.*3.2v//'`
171 5) UNAME_S
=OpenServer6
176 DEF_MSG
="(default: n)"
180 case `basename $0` in
182 ## Start by faking root install
183 echo "Faking root install..."
184 [ -d $FAKE_ROOT ] && rm -fr $FAKE_ROOT
186 ${MAKE} install-nokeys DESTDIR
=$FAKE_ROOT
189 echo "Fake root install failed, stopping."
193 ## Setup our run level stuff while we are at it.
196 # For Solaris' SMF, /lib/svc/method/site is the preferred place
197 # for start/stop scripts that aren't supplied with the OS, and
198 # similarly /var/svc/manifest/site for manifests.
199 mkdir
-p $FAKE_ROOT${TEST_DIR}/lib
/svc
/method
/site
200 mkdir
-p $FAKE_ROOT${TEST_DIR}/var
/svc
/manifest
/site
202 cp ${OPENSSHD} $FAKE_ROOT${TEST_DIR}/lib/svc/method/site/${SYSVINIT_NAME}
203 chmod 744 $FAKE_ROOT${TEST_DIR}/lib
/svc
/method
/site
/${SYSVINIT_NAME}
205 cat ${OPENSSH_MANIFEST} |
sed "s|__SYSVINIT_NAME__|${SYSVINIT_NAME}|" \
206 > $FAKE_ROOT${TEST_DIR}/var
/svc
/manifest
/site
/${SYSVINIT_NAME}.xml
207 chmod 644 $FAKE_ROOT${TEST_DIR}/var
/svc
/manifest
/site
/${SYSVINIT_NAME}.xml
209 mkdir
-p $FAKE_ROOT${TEST_DIR}/etc
/init.d
211 cp ${OPENSSHD} $FAKE_ROOT${TEST_DIR}/etc/init.d/${SYSVINIT_NAME}
212 chmod 744 $FAKE_ROOT${TEST_DIR}/etc
/init.d
/${SYSVINIT_NAME}
215 [ "${PERMIT_ROOT_LOGIN}" = no
] && \
216 perl
-p -i -e "s/#PermitRootLogin yes/PermitRootLogin no/" \
217 $FAKE_ROOT/${sysconfdir}/sshd_config
218 [ "${X11_FORWARDING}" = yes ] && \
219 perl
-p -i -e "s/#X11Forwarding no/X11Forwarding yes/" \
220 $FAKE_ROOT/${sysconfdir}/sshd_config
222 perl
-p -i -e "s/#PrintMotd yes/PrintMotd no/" \
223 $FAKE_ROOT/${sysconfdir}/sshd_config
225 # We don't want to overwrite config files on multiple installs
226 mv $FAKE_ROOT/${sysconfdir}/ssh_config
$FAKE_ROOT/${sysconfdir}/ssh_config.default
227 mv $FAKE_ROOT/${sysconfdir}/sshd_config
$FAKE_ROOT/${sysconfdir}/sshd_config.default
228 [ -f $FAKE_ROOT/${sysconfdir}/ssh_prng_cmds
] && \
229 mv $FAKE_ROOT/${sysconfdir}/ssh_prng_cmds
$FAKE_ROOT/${sysconfdir}/ssh_prng_cmds.default
232 [ -s "${POST_MAKE_INSTALL_FIXES}" ] && .
${POST_MAKE_INSTALL_FIXES}
236 ## Ok, this is outright wrong, but it will work. I'm tired of pkgmk
239 PROTO_ARGS
="$PROTO_ARGS $i=/$i";
243 echo "Building pkginfo file..."
244 cat > pkginfo
<< _EOF
246 NAME="OpenSSH Portable for ${UNAME_S}"
247 DESC="Secure Shell remote access utility; replaces telnet and rlogin/rsh."
248 VENDOR="OpenSSH Portable Team - http://www.openssh.com/portable.html"
251 CATEGORY="Security,application"
254 PSTAMP="${UNAME_S} ${OS_VER} ${ARCH} `date '+%d%b%Y %H:%M'`"
257 ## Build empty depend file that may get updated by $POST_PROTOTYPE_EDITS
258 echo "Building depend file..."
262 echo "Building space file..."
265 # XXX Is this necessary? If not, remove space line from mk-proto.awk.
269 # extra space required by start/stop links added by installf
271 $TEST_DIR/etc/rc0.d/${SYSVINITSTOPT}${SYSVINIT_NAME} 0 1
272 $TEST_DIR/etc/rc2.d/${SYSVINITSTART}${SYSVINIT_NAME} 0 1
274 [ "$RC1_D" = no
] || \
275 echo "$TEST_DIR/etc/rc1.d/${SYSVINITSTOPT}${SYSVINIT_NAME} 0 1" >> space
276 [ "$RCS_D" = yes ] && \
277 echo "$TEST_DIR/etc/rcS.d/${SYSVINITSTOPT}${SYSVINIT_NAME} 0 1" >> space
280 ## Build preinstall file
281 echo "Building preinstall file..."
282 cat > preinstall
<< _EOF
287 # local preinstall changes here
288 [ -s "${PKG_PREINSTALL_LOCAL}" ] && .
${PKG_PREINSTALL_LOCAL}
290 cat >> preinstall
<< _EOF
292 if [ "\${PRE_INS_STOP}" = "yes" ]
296 svcadm disable $OPENSSH_FMRI
298 ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} stop
305 ## Build postinstall file
306 echo "Building postinstall file..."
307 cat > postinstall
<< _EOF
310 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_config ] || \\
311 cp -p \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_config.default \\
312 \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_config
313 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/sshd_config ] || \\
314 cp -p \${PKG_INSTALL_ROOT}${sysconfdir}/sshd_config.default \\
315 \${PKG_INSTALL_ROOT}${sysconfdir}/sshd_config
316 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds.default ] && {
317 [ -f \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds ] || \\
318 cp -p \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds.default \\
319 \${PKG_INSTALL_ROOT}${sysconfdir}/ssh_prng_cmds
322 # make rc?.d dirs only if we are doing a test install
323 [ -n "${TEST_DIR}" ] && [ $DO_SMF -ne 1 ] && {
324 [ "$RCS_D" = yes ] && mkdir -p ${TEST_DIR}/etc/rcS.d
325 mkdir -p ${TEST_DIR}/etc/rc0.d
326 [ "$RC1_D" = no ] || mkdir -p ${TEST_DIR}/etc/rc1.d
327 mkdir -p ${TEST_DIR}/etc/rc2.d
332 # Delete the existing service, if it exists, then import the
334 if svcs $OPENSSH_FMRI > /dev/null 2>&1
336 svccfg delete -f $OPENSSH_FMRI
338 # NOTE, The manifest disables sshd by default.
339 svccfg import ${TEST_DIR}/var/svc/manifest/site/${SYSVINIT_NAME}.xml
341 if [ "\${USE_SYM_LINKS}" = yes ]
343 [ "$RCS_D" = yes ] && \
344 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rcS.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
345 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc0.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
346 [ "$RC1_D" = no ] || \
347 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc1.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
348 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc2.d/${SYSVINITSTART}${SYSVINIT_NAME}=../init.d/${SYSVINIT_NAME} s
350 [ "$RCS_D" = yes ] && \
351 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rcS.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
352 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc0.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
353 [ "$RC1_D" = no ] || \
354 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc1.d/${SYSVINITSTOPT}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
355 installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR/etc/rc2.d/${SYSVINITSTART}${SYSVINIT_NAME}=\${PKG_INSTALL_ROOT}$TEST_DIR/etc/init.d/${SYSVINIT_NAME} l
359 # If piddir doesn't exist we add it. (Ie. --with-pid-dir=/var/opt/ssh)
360 [ -d $piddir ] || installf ${PKGNAME} \${PKG_INSTALL_ROOT}$TEST_DIR$piddir d 0755 root sys
364 # local postinstall changes here
365 [ -s "${PKG_POSTINSTALL_LOCAL}" ] && .
${PKG_POSTINSTALL_LOCAL}
367 cat >> postinstall
<< _EOF
368 installf -f ${PKGNAME}
370 # Use chroot to handle PKG_INSTALL_ROOT
371 if [ ! -z "\${PKG_INSTALL_ROOT}" ]
373 chroot="chroot \${PKG_INSTALL_ROOT}"
375 # If this is a test build, we will skip the groupadd/useradd/passwd commands
376 if [ ! -z "${TEST_DIR}" ]
381 echo "PrivilegeSeparation user always required."
382 if cut -f1 -d: \${PKG_INSTALL_ROOT}/etc/passwd | egrep '^'$SSH_PRIVSEP_USER'\$' >/dev/null
384 echo "PrivSep user $SSH_PRIVSEP_USER already exists."
385 SSH_PRIVSEP_GROUP=\`grep "^$SSH_PRIVSEP_USER:" \${PKG_INSTALL_ROOT}/etc/passwd | awk -F: '{print \$4}'\`
386 SSH_PRIVSEP_GROUP=\`grep ":\$SSH_PRIVSEP_GROUP:" \${PKG_INSTALL_ROOT}/etc/group | awk -F: '{print \$1}'\`
390 [ -z "\$SSH_PRIVSEP_GROUP" ] && SSH_PRIVSEP_GROUP=$SSH_PRIVSEP_USER
393 if cut -f1 -d: \${PKG_INSTALL_ROOT}/etc/group | egrep '^'\$SSH_PRIVSEP_GROUP'\$' >/dev/null
395 echo "PrivSep group \$SSH_PRIVSEP_GROUP already exists."
400 # create group if required
401 [ "\$DO_GROUP" = yes ] && {
402 # Use gid of 67 if possible
403 if cut -f3 -d: \${PKG_INSTALL_ROOT}/etc/group | egrep '^'$SSHDGID'\$' >/dev/null
407 sshdgid="-g $SSHDGID"
409 echo "Creating PrivSep group \$SSH_PRIVSEP_GROUP."
410 \$chroot ${PATH_GROUPADD_PROG} \$sshdgid \$SSH_PRIVSEP_GROUP
413 # Create user if required
414 [ "\$DO_PASSWD" = yes ] && {
415 # Use uid of 67 if possible
416 if cut -f3 -d: \${PKG_INSTALL_ROOT}/etc/passwd | egrep '^'$SSHDUID'\$' >/dev/null
420 sshduid="-u $SSHDUID"
422 echo "Creating PrivSep user $SSH_PRIVSEP_USER."
423 \$chroot ${PATH_USERADD_PROG} -c 'SSHD PrivSep User' -s /bin/false -g $SSH_PRIVSEP_USER \$sshduid $SSH_PRIVSEP_USER
424 \$chroot ${PATH_PASSWD_PROG} -l $SSH_PRIVSEP_USER
427 if [ "\${POST_INS_START}" = "yes" ]
431 svcadm enable $OPENSSH_FMRI
433 ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} start
439 ## Build preremove file
440 echo "Building preremove file..."
441 cat > preremove
<< _EOF
446 svcadm disable $OPENSSH_FMRI
448 ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} stop
452 # local preremove changes here
453 [ -s "${PKG_PREREMOVE_LOCAL}" ] && .
${PKG_PREREMOVE_LOCAL}
455 cat >> preremove
<< _EOF
459 ## Build postremove file
460 echo "Building postremove file..."
461 cat > postremove
<< _EOF
466 if svcs $OPENSSH_FMRI > /dev/null 2>&1
468 svccfg delete -f $OPENSSH_FMRI
473 # local postremove changes here
474 [ -s "${PKG_POSTREMOVE_LOCAL}" ] && .
${PKG_POSTREMOVE_LOCAL}
476 cat >> postremove
<< _EOF
480 ## Build request file
481 echo "Building request file..."
482 cat > request
<< _EOF
487 [ -x /usr
/bin
/ckyorn
] ||
cat >> request
<< _EOF
490 # for some strange reason OpenServer5 has no ckyorn
491 # We build a striped down version here
494 PROMPT="Yes or No [yes,no,?,quit]"
495 HELP_PROMPT=" Enter y or yes if your answer is yes; n or no if your answer is no."
496 USAGE="usage: ckyorn [options]
497 where options may include:
505 while getopts d:p:h: c
508 h) HELP_PROMPT="\$OPTARG" ;;
509 d) DEFAULT=\$OPTARG ;;
510 p) PROMPT=\$OPTARG ;;
511 \\?) echo "\$USAGE" 1>&2
515 shift \`expr \$OPTIND - 1\`
520 echo "\${PROMPT}\\c " 1>&2
522 [ -z "\$key" ] && key=\$DEFAULT
524 [n,N]|[n,N][o,O]|[y,Y]|[y,Y][e,E][s,S]) echo "\${key}\\c"
526 \\?) echo \$HELP_PROMPT 1>&2 ;;
527 q|quit) echo "q\\c" 1>&2
538 # This could get hairy, as the running sshd may not be under SMF.
539 # We'll assume an earlier version of OpenSSH started via SMF.
540 cat >> request
<< _EOF
543 # determine if should restart the daemon
544 if [ -s ${piddir}/sshd.pid ] && \
545 /usr/bin/svcs -H $OPENSSH_FMRI 2>&1 | egrep "^online" > /dev/null 2>&1
548 -p "Should the running sshd daemon be restarted? ${DEF_MSG}"\` || exit \$?
550 [y,Y]*) PRE_INS_STOP=yes
557 # determine if we should start sshd
559 -p "Start the sshd daemon after installing this package? ${DEF_MSG}"\` || exit \$?
561 [y,Y]*) POST_INS_START=yes ;;
565 # make parameters available to installation service,
566 # and so to any other packaging scripts
568 PRE_INS_STOP='\$PRE_INS_STOP'
569 POST_INS_START='\$POST_INS_START'
574 cat >> request
<< _EOF
578 # Use symbolic links?
580 -p "Do you want symbolic links for the start/stop scripts? ${DEF_MSG}"\` || exit \$?
582 [y,Y]*) USE_SYM_LINKS=yes ;;
585 # determine if should restart the daemon
586 if [ -s ${piddir}/sshd.pid -a -f ${TEST_DIR}/etc/init.d/${SYSVINIT_NAME} ]
589 -p "Should the running sshd daemon be restarted? ${DEF_MSG}"\` || exit \$?
591 [y,Y]*) PRE_INS_STOP=yes
598 # determine if we should start sshd
600 -p "Start the sshd daemon after installing this package? ${DEF_MSG}"\` || exit \$?
602 [y,Y]*) POST_INS_START=yes ;;
606 # make parameters available to installation service,
607 # and so to any other packaging scripts
609 USE_SYM_LINKS='\$USE_SYM_LINKS'
610 PRE_INS_STOP='\$PRE_INS_STOP'
611 POST_INS_START='\$POST_INS_START'
617 # local request changes here
618 [ -s "${PKG_REQUEST_LOCAL}" ] && .
${PKG_REQUEST_LOCAL}
620 cat >> request
<< _EOF
625 ## Next Build our prototype
626 echo "Building prototype file..."
627 cat >mk-proto.
awk << _EOF
628 BEGIN { print "i pkginfo"; print "i depend"; \\
629 print "i preinstall"; print "i postinstall"; \\
630 print "i preremove"; print "i postremove"; \\
631 print "i request"; print "i space"; \\
632 split("$SYSTEM_DIR",sys_files); }
634 for (dir in sys_files) { if ( \$3 != sys_files[dir] )
638 { \$5="root"; \$6="sys"; }
641 { \$4="?"; \$5="?"; \$6="?"; break;}
646 find . |
egrep -v "prototype|pkginfo|mk-proto.awk" |
sort | \
647 pkgproto
$PROTO_ARGS |
${AWK} -f mk-proto.
awk > prototype
649 # /usr/local is a symlink on some systems
650 [ "${USR_LOCAL_IS_SYMLINK}" = yes ] && {
651 grep -v "^d none /usr/local ? ? ?$" prototype
> prototype.new
652 mv prototype.new prototype
655 ## Step back a directory and now build the package.
657 # local prototype tweeks here
658 [ -s "${POST_PROTOTYPE_EDITS}" ] && .
${POST_PROTOTYPE_EDITS}
660 echo "Building package.."
661 pkgmk
-d ${FAKE_ROOT} -f $FAKE_ROOT/prototype
-o
662 echo | pkgtrans
-os ${FAKE_ROOT} ${START}/$PKGNAME-$VERSION$REV-$UNAME_S-$ARCH.pkg
666 rm -fr ${FAKE_ROOT}/${PKGNAME}
667 grep -v "^PSTAMP=" $FAKE_ROOT/pkginfo
> $
$tmp
668 mv $
$tmp $FAKE_ROOT/pkginfo
669 cat >> $FAKE_ROOT/pkginfo
<< _EOF
670 PSTAMP="${UNAME_S} ${OS_VER} ${ARCH} `date '+%d%b%Y %H:%M'`"
672 pkgmk
-d ${FAKE_ROOT} -f $FAKE_ROOT/prototype
-o
673 echo | pkgtrans
-os ${FAKE_ROOT} ${START}/$PKGNAME-$VERSION$REV-$UNAME_S-$ARCH.pkg
678 [ "${REMOVE_FAKE_ROOT_WHEN_DONE}" = yes ] && rm -rf $FAKE_ROOT